automake-patches
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

Re: define ACLOCAL_M4 even in subdirectories


From: Alexandre Duret-Lutz
Subject: Re: define ACLOCAL_M4 even in subdirectories
Date: Fri, 14 Mar 2003 22:52:52 +0100
User-agent: Gnus/5.090016 (Oort Gnus v0.16) Emacs/21.2 (gnu/linux)

>>> "Jim" == Jim Meyering <address@hidden> writes:

[...]

 >> 2003-03-14  Jim Meyering  <address@hidden>
 >> 
 >> * automake.in (scan_aclocal_m4): Define ACLOCAL_M4 even in
 >> subdirectories.  Makefile.in depends on that variable.


Thanks Jim!  I've installed your patch on HEAD and branch-1-7
(without the `INTERNAL' on branch-1-7 :))

And I've also installed the following test case.

2003-03-14  Alexandre Duret-Lutz  <address@hidden>

        * tests/aclocal4.test: New file. Test for ACLOCAL_M4 bug below.
        * tests/Makefile.am (TESTS): Add aclocal4.test.

Index: tests/Makefile.am
===================================================================
RCS file: /cvs/automake/automake/tests/Makefile.am,v
retrieving revision 1.475
diff -u -r1.475 Makefile.am
--- tests/Makefile.am   26 Feb 2003 20:53:48 -0000      1.475
+++ tests/Makefile.am   14 Mar 2003 21:52:38 -0000
@@ -10,6 +10,7 @@
 aclocal.test \
 aclocal2.test \
 aclocal3.test \
+aclocal4.test \
 acoutnoq.test \
 acoutpt.test \
 acoutpt2.test \
Index: tests/aclocal4.test
===================================================================
RCS file: tests/aclocal4.test
diff -N tests/aclocal4.test
--- /dev/null   1 Jan 1970 00:00:00 -0000
+++ tests/aclocal4.test 14 Mar 2003 21:52:38 -0000
@@ -0,0 +1,79 @@
+#! /bin/sh
+# Copyright (C) 2003  Free Software Foundation, Inc.
+#
+# This file is part of GNU Automake.
+#
+# GNU Automake is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# GNU Automake is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with Automake; see the file COPYING.  If not, write to
+# the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+# Boston, MA 02111-1307, USA.
+
+# Make sure dependencies on aclocal.m4 are set correctly.
+# Report from Jim Meyering.
+
+# We need GNU make for the `rebuild rules' to be triggered.
+required=make
+. ./defs || exit 1
+
+set -e
+
+cat >>configure.in <<EOF
+AC_PROG_RANLIB
+AC_PROG_CC
+MY_MACRO
+AC_CONFIG_FILES([lib/Makefile])
+AC_OUTPUT
+EOF
+
+mkdir m4
+cat >m4/mymacro.m4 <<EOF
+AC_DEFUN([MY_MACRO], [])
+EOF
+
+mkdir lib
+: > lib/foo.c
+: > lib/bar.c
+cat >lib/Makefile.am <<'EOF'
+noinst_LIBRARIES = liberi.a
+liberi_a_SOURCES = bar.c
+liberi_a_LIBADD = $(LIBOBJS)
+EOF
+
+cat >Makefile.am <<'EOF'
+SUBDIRS = lib
+EXTRA_DIST = m4/mymacro.m4
+ACLOCAL_AMFLAGS = -I m4
+check-foo: distdir
+       test -f $(distdir)/lib/foo.c
+       test -f $(distdir)/lib/bar.c
+
+check-not-foo: distdir
+       test ! -f $(distdir)/lib/foo.c
+       test -f $(distdir)/lib/bar.c
+EOF
+
+$ACLOCAL -I m4
+$AUTOCONF
+$AUTOMAKE
+./configure
+$MAKE check-not-foo
+
+# Update one of the macros.  This should cause ./configure, Makefile.in,
+# Makefile, lib/Makefile.in, and lib/Makfile to be updated.  This assumes
+# GNU make.
+
+cat >m4/mymacro.m4 <<'EOF'
+AC_DEFUN([MY_MACRO], [AC_LIBOBJ([foo])])
+EOF
+
+$MAKE check-foo

-- 
Alexandre Duret-Lutz





reply via email to

[Prev in Thread] Current Thread [Next in Thread]